image: 177.105.35.54:5000/zetta-builder:latest

stages:
    - build
    - deploy

build:
    only: 
        - development
        - homologation
        - production
    stage: build
    script:
        - bash /n 9.6.1
        - cd /builds/imasul/licenciamento/frontend
        - npm install
        - bower install --allow-root
        - bower update --allow-root
        - gulp dist

deploy_dev:
    only: 
        - development
    stage: deploy
    script:
        - cd /builds/imasul/licenciamento/backend
        - rm -rf public
        - /opt/play-1.5.1/play deps --sync
        - cd /builds/imasul/licenciamento/frontend
        - bash /n 9.6.1
        - npm install
        - bower install --allow-root
        - bower update --allow-root
        - gulp dist
        - cd /builds/imasul/licenciamento/backend
        - mkdir -p /builds/imasul/licenciamento/dist
        - cp -R app conf lib modules db public /builds/imasul/licenciamento/dist/
        - echo "" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - echo "server.version=Development" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - echo "server.update=$(TZ='America/Sao_Paulo' date +%d-%m-%Y\ %H:%M:%S)" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - echo "server.name=imasul.ti.lemaf.ufla.br" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - echo "server.geradaPor=GITLAB-CI" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - echo "@include.production = ambientes/runners.conf" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - cd /builds/imasul/licenciamento
        - zip -r release-licenciamento-imasul.zip dist
        - sshpass -p "$SSH_HOST_TESTE_SENHA" scp -v -o StrictHostKeyChecking=no release-licenciamento-imasul.zip $SSH_HOST_TESTE_USER@$SSH_HOST_TESTE:/var/tmp   
        - sshpass -p "$SSH_HOST_TESTE_SENHA" ssh -tt -o StrictHostKeyChecking=no $SSH_HOST_TESTE_USER@$SSH_HOST_TESTE 'unzip /var/tmp/release-licenciamento-imasul.zip -d /var/tmp; cp -rf /var/tmp/dist/* /var/play/imasul/licenciamento_ambiental/licenciamento_simplificado/; sudo /usr/bin/systemctl restart licenciamento-simplificado-ms.service; rm -rf /var/tmp/dist /var/tmp/release-licenciamento-imasul.zip' 

deploy_homologation:
    only: 
        - homologation
    stage: deploy
    script:
        - cd /builds/imasul/licenciamento/backend
        - rm -rf public
        - /opt/play-1.5.1/play deps --sync
        - cd /builds/imasul/licenciamento/frontend
        - bash /n 9.6.1
        - npm install
        - bower install --allow-root
        - bower update --allow-root
        - grunt homologacao
        - cd /builds/imasul/licenciamento/backend
        - cp -R app conf lib modules db public /builds/imasul/licenciamento/dist/
        - echo "" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - echo "server.version=Homologation" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - echo "server.update=$(TZ='America/Sao_Paulo' date +%d-%m-%Y\ %H:%M:%S)" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - echo "server.name=sema-car-vmapp01" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - echo "server.geradaPor=GITLAB-CI" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - echo "@include.production = ambientes/homologacao.conf" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - cd /builds/imasul/licenciamento
        - zip -r release-licenciamento-imasul-homolog.zip dist
        - vpnc-connect /etc/vpnc/vpn-prodap
        - sshpass -p "$SSH_HOST_HOMOLOG_SENHA" scp -P 15012 -v -o StrictHostKeyChecking=no release-licenciamento-imasul-homolog.zip $SSH_HOST_HOMOLOG_USER@$SSH_HOST_HOMOLOG:/var/tmp  
        - sshpass -p "$SSH_HOST_HOMOLOG_SENHA" ssh -p 15012 -tt -o StrictHostKeyChecking=no $SSH_HOST_HOMOLOG_USER@$SSH_HOST_HOMOLOG 'unzip /var/tmp/release-licenciamento-imasul-homolog.zip -d /var/tmp; tar czvf /var/tmp/licenciamento-ms-homolog-bkp-$(date  +%d-%m-%Y-%H.%M.%S).tgz /dados/var/play/licenciamento-ambiental/licenciamento-ambiental/ ;cp -rf /var/tmp/dist/* /dados/var/play/licenciamento-ambiental/licenciamento-ambiental/; sudo /usr/bin/systemctl restart licenciamento-simplificado.service; rm -rf /var/tmp/dist /var/tmp/release-licenciamento-imasul-homolog.zip' 
        - vpnc-disconnect

deploy_production:
    only: 
        - production
    stage: deploy
    script:
        - cd /builds/imasul/licenciamento/backend
        - rm -rf public
        - /opt/play-1.5.1/play deps --sync
        - cd /builds/imasul/licenciamento/frontend
        - bash /n 9.6.1
        - npm install
        - bower install --allow-root
        - bower update --allow-root
        - grunt production
        - cd /builds/imasul/licenciamento/backend
        - cp -R app conf lib modules db public /builds/imasul/licenciamento/dist/
        - echo "" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - echo "server.version=Production" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - echo "server.update=$(TZ='America/Sao_Paulo' date +%d-%m-%Y\ %H:%M:%S)" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - echo "server.name=sema-car-gd-fisc-sig-prod" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - echo "server.geradaPor=GITLAB-CI" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - echo "@include.production = ambientes/producao.conf" >> /builds/imasul/licenciamento/dist/conf/application.conf
        - cd /builds/imasul/licenciamento
        - zip -r release-licenciamento-imasul-prod.zip dist
        - vpnc-connect /etc/vpnc/vpn-prodap
        - sshpass -p "$SSH_HOST_PROD_SENHA" scp -P 15012 -v -o StrictHostKeyChecking=no release-licenciamento-imasul-prod.zip $SSH_HOST_PROD_USER@$SSH_HOST_PROD:/var/tmp  
        - sshpass -p "$SSH_HOST_PROD_SENHA" ssh -p 15012 -tt -o StrictHostKeyChecking=no $SSH_HOST_PROD_USER@$SSH_HOST_PROD 'unzip /var/tmp/release-licenciamento-imasul-prod.zip -d /var/tmp; tar czvf /var/tmp/dashboard-ap-prod-bkp-$(date  +%d-%m-%Y-%H.%M.%S).tgz /var/application/dashboard/ ;cp -rf /var/tmp/dist/* /var/application/dashboard/; sudo /usr/bin/systemctl restart dashboard.service; rm -rf /var/tmp/dist /var/tmp/release-licenciamento-imasul-prod.zip' 
        - vpnc-disconnect